/*
	This is the "bare bones" linker/relocation test.
	DO NOT USE THIS as your boiler plate. Refer to a different app which just includes "app.h" instead.
	
	This file is solely used to test new functions before putting them into the app.h include file
	
*/

//#include <app.h>	// We do not use the app header, but do everything manually in the global context instead
#define NULL (void *)0
int main(int argc, char *argv[]);	// Forward declaration to main(), so it can be defined later and start() is the first instruction in the binary
void start() {	// First function declaration
	
	// First instruction! This should be the first memory cell of the binary
	main(0, NULL);
	
}

#include <api.h>	// At least, include the API definitions


// External linking:
// The loader uses the actual NAME of unresolved externals to link them to run-time symbols
extern const t_putchar putchar;
extern const t_getchar getchar;
extern const t_printf printf;
extern const t_sprintf sprintf;
extern const t_gets gets;
extern const t_clear clear;
extern const t_beep beep;

extern const t_api api;	// "api" will be linked to the actual API implementation

/*
// Access test

typedef struct {
	byte k1b;
	word k2w;
	byte k3b;
	byte k4b;
} t_s;

byte global1b;
word global2w;
word global3w;
t_s global4s;
byte global5b;
byte global6b;

void foo() {
	//
}

void main() {
	global1b = 0x11;
	global2w = 0x2222;
	global3w = 0x3333;
	global4s.k1b = 0x41;
	global4s.k2w = 0x4242;
	global4s.k3b = 0x44;
	global4s.k4b = 0x45;
	global5b = 0x55;
	global6b = 0x66;
	
	foo();
	
	api_putchar(0x01);
	api_getchar();
	
	api.putchar(0x00);
	api.beep();
	//api.version;
	
}
*/


byte state1;
word state2;

/*
//volatile __at (0x1234) byte absPointerTo1234;	// Just for testing
volatile __at (0x8353) void (*at_putchar)(char);

const char testText[13] = {'H','e','l','l','o',' ','w','o','r','l','d','!', '\n'};

const char hexDigits[16] = {'0', '1', '2', '3', '4', '5', '6', '7', '8', '9', 'A', 'B', 'C', 'D', 'E', 'F'};
void put_hex16(word v) {
	byte i;
	for (i = 0; i < 4; i++) {
		putchar(hexDigits[(v >> (4 * (3-i))) % 0x10]);
	}
}
*/


char s[32];
int main(int argc, char *argv[]) {
	byte i;
	
	api.putchar('A');
	
	state1 = 0x11;
	state2 = 0x21;
	
	//printf("APP\n");
	//put('A');
	//put('P');
	//put('P');
	
	
	for(i = 0; i < 3; i++) {
		//at_putchar('T');
		putchar('T');
	}
	//while(1) {}
	
	state1 = 0x12;
	state2 = 0x2222;
	
	getchar();
	clear();
	
	printf("argc=%d\n", argc);
	for(i = 0; i < argc; i++) {
		printf("arg%d=\"%s\"\n", i, argv[i]);
	}
	//getchar();
	
	printf("Enter something:");
	gets(s);
	printf("s=\"%s\"", s);
	getchar();
	
	/*
	
	for(i = 0; i < sizeof(testText); i++) {
		putchar(testText[i]);
	}
	getchar();
	//beep();
	
	absPointerTo1234 = 0x45;
	*/
	
	//put_hex16(0x1234);
	//putchar('\n');
	
	//put('\n');
	//beep();
	
	/*
	// Test external API (pointer)
	p_api = a_api;
	p_api->putchar('A');
	p_api->putchar('P');
	p_api->putchar('I');
	
	
	// Test the API (mapped at relocation time)
	api.putchar('A');
	api.putchar('P');
	api.putchar('I');
	api.getchar();
	api.beep();
	api.printf("api.printf %04X", state2);
	*/
	
	/*
	putchar('A='); put_hex16((word)(api));
	putchar('p'); put_hex16((word)(api.putchar));
	putchar('g'); put_hex16((word)(api.getchar));
	putchar('c'); put_hex16((word)(api.clear));
	putchar('b'); put_hex16((word)(api.beep));
	printf("printf %04X", state2);
	//printf("End of app.");
	
	state1 = 0x13;
	state2 = 0x23;
	*/
	
	//while(1) {}
	
	return 1;
}
