
#include <vgl.h>
#include <stdio.h>

const len = 16;
void dump(word a) {
	byte i;
	byte b;
	byte *o;
	
	//clear();
	
	printf("%04X", a);
	o = (byte *)a;
	for(i = 0; i < len; i++) {
		b = *o;
		//printf("%02X", b);
		if (b < 0x20)
			putchar('.');
		else
			putchar(b);
		o++;
	}
	
	/*
	printf("\n");
	o = (byte *)a;
	for(i = 0; i < len; i++) {
		b = *o;
		printf("%02X", b);
		o++;
	}
	*/

}
byte gethexchar() {
	char c = getchar();
	if ((c >= '0') && (c <= '9')) return c - '0';
	else if ((c >= 'A') && (c <= 'F')) return c - 'A' + 0x0a;
	else if ((c >= 'a') && (c <= 'f')) return c - 'a' + 0x0a;
	return 0;
}
word gethex(byte digits) {
	word v;
	byte b;
	byte i;
	
	v = 0;
	for(i = 0; i < digits; i++) {
		printf("_\b");
		b = gethexchar();
		printf("%01X", b);
		v = v * 0x10 + b;
	}
	return v;
}

word o;
void main() {
	byte b;
	byte v;
	char c;
	
	vgl_lcd_init();
	
	printf("Hello world!");
	beep();
	clear();
	
	
	//printf("printf");
	
	o = 0x0000;
	
	while(1) {
		clear();
		
		//printf("%04X\n", o);
		//printf("%04X", o);
		dump(o);
		printf("\n");
		
		c = getchar();
		//printf("%d", c);
		//putchar(c);
		//beep();
		
		switch((byte)c) {
		case KEY_CURSOR_LEFT:
			o -= len;
			break;
		case KEY_CURSOR_RIGHT:
			o += len;
			break;
		case 'r':
			// nothing
			break;
		case 'b':
			// Bank
			printf("Switch B #");
			b = gethex(1);
			printf("to 0x");
			v = gethex(2);
			vgl_switchBank(b, v);
			break;
		case 'a':
			// addr
			printf("Addr: 0x");
			o = gethex(4);
			break;
		case 29:	// MAME Page Down
			o += 0x0100;
			break;
		case 28:	// MAME Page Up
			o -= 0x0100;
			break;
		default:
			// Unhandled key
			printf("Unhandled: %d / 0x%02X / ", c, c);
			putchar(c);
			beep();
			delay(0x7000);
		}
	}
	
}
