/*
	Test bed for analyzing all kinds of compiler foo
	(e.g. looking at the call conventions and register usage, checking byte offsets, code overlap etc.)
*/

//#include <vgl.h>
//#include <stdio.h>
#define byte unsigned char
#define word unsigned int

volatile byte someByte;
volatile word someWord;

void testPointerAndLength(byte *data, byte l) {
	//volatile int i;
	//volatile int j;
	
	//i = 0x1234;
	someWord = (word)data + 0x6666;
	//j = 0x4321;
	someByte = l + 0x55;
}


/*
int testReturnMinus() {
	return -1;
}

char testReturnByte() {
	return 3;
}
char testReturnInline() __naked {
__asm
	ld	a, #4
	ld	l, a
	ret
__endasm;
}


void testWriteByte(byte c) {
	someByte = c;
}
void inline testWriteByteInline(byte c) {
	someByte = c;
}
void inline testWritePortInlineAsm(byte c) {
(void)c;	// Suppress warning "unreferenced"
__asm
	out	(#0x10), a
__endasm;
}

void testWriteWords(word frq, word len) {
	someWord = frq;
	someWord += len;
}

void testPassPointer(byte *b) {
	*b = 3;
}
*/

//#include <vgl_printer.h>


void main() {
	volatile char a;
	//char b;
	volatile int i;
	
	a = 0x12;
	a = 0x34;
	//a = testReturnInline();
	//testWriteByte(a);
	//testWriteByteInline(a);
	//testWritePortInlineAsm(a);
	//i = testReturnMinus();
	testPointerAndLength(&someByte, 0x99);
	
	a = 0x56;
	a = 0x78;
	
	/*
	a = 0x12;
	a = 0x34;
	
	b = testReturnByte();
	
	a = b + 0x56;
	a = 0x78;
	
	a = testReturnInline();
	
	a = 0x01;
	a = 0x23;
	*/
	
	// Bare minimum hardware init
	//vgl_lcd_init();
	//vgl_sound_off();
	
	
	/*
	// Test sound
	for(c = 0; c < 1; c++) {
		vgl_sound_note(12*4 + 0, 1000);
		vgl_sound_note(12*3 + 0, 1000);
	}
	vgl_sound_note(12*4 + 2, 250);
	vgl_sound_note(12*4 + 4, 500);
	vgl_sound_note(12*4 + 0, 250);
	*/
	
	/*
	// Try defining a custom LCD char
	// http://www.8051projects.net/lcd-interfacing/lcd-custom-character.php
	
	vgl_lcd_writeControl(0x40);       //Load the location where we want to store
	vgl_lcd_writeControl(0x04);      //Load row 1 data
	vgl_lcd_writeControl(0x0E);      //Load row 2 data
	vgl_lcd_writeControl(0x04);      //Load row 3 data
	vgl_lcd_writeControl(0x0E);      //Load row 4 data
	vgl_lcd_writeControl(0x0E);      //Load row 5 data
	vgl_lcd_writeControl(0x0E);      //Load row 6 data
	vgl_lcd_writeControl(0x1F);      //Load row 7 data
	vgl_lcd_writeControl(0x1B);      //Load row 8 data
	
	vgl_lcd_putchar(0x00);	// Display 0x00 = location 0x40
	*/
	
	/*
	
	printf("Hello world!");
	//c = testReturnByte();
	//testWriteWords(1000, 2000);
	
	vgl_printer_putChar('T');
	vgl_printer_putChar('E');
	vgl_printer_putChar('S');
	vgl_printer_putChar('T');
	
	
	while(1) {
		c = getchar();
		//beep();
		
		switch((byte)c) {
		case KEY_CURSOR_LEFT:
			break;
		case KEY_CURSOR_RIGHT:
			break;
		default:
			// Unhandled key
			printf("Unhandled: %d / 0x%02X / ", c, c);
			putchar(c);
			beep();
		}
	}
	*/
}
