/*
An "app" that accesses the common API through a pointer
*/

#include <app.h>

const char testText[10] = {'A','P','I',' ','T','e','s','t','!', '\n'};

char s[32];

int main(int argc, char *argv[]) {
	byte i;
	
	
	for(i = 0; i < sizeof(testText); i++) {
		//ext_putchar('A');
		api.putchar(testText[i]);
	}
	
	
	// Test the API (mapped at relocation time)
	api.putchar('a');
	api.putchar('p');
	api.putchar('i');
	api.beep();
	api.putchar('T');
	api.putchar('e');
	api.putchar('s');
	api.putchar('t');
	
	api.getchar();
	api.clear();
	
	api.printf("api.printf %04X\n", 0x1234);
	api.getchar();
	
	printf("printf %04X\n", 0x5678);
	api.getchar();
	
	printf("API version %04X\n", api.version);
	api.getchar();
	
	printf("argc=%d\n", argc);
	for(i = 0; i < argc; i++) {
		api.printf("arg%d=\"%s\"\n", i, argv[i]);
	}
	//api.getchar();
	
	api.printf("Enter something:");
	api.gets(s);
	api.printf("s=\"%s\"", s);
	api.getchar();
	
	return api.version;
}
