#!/bin/sh

NAME=serloader

#PART=AT28C64B
PART=CAT28C64B

OUT_DIR=out
LIB_DIR=`realpath ../includes`
INC_DIR=${LIB_DIR}

BIN_FILE=${OUT_DIR}/${NAME}.bin

echo Burning file "${BIN_FILE}"...

# -s = no warning for file size mismatch
minipro -p "${PART}" -w ${BIN_FILE}


RETVAL=$?
[ $RETVAL -eq 0 ] && echo Minipro return value: Success
[ $RETVAL -ne 0 ] && echo Minipro return value: Failure
echo Done.